# -*- encoding : utf-8 -*-
require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe TweetsController do

  # This should return the minimal set of attributes required to create a valid
  # Tweet. As you add validations to Tweet, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all tweets as @tweets" do
      tweet = Tweet.create! valid_attributes
      get :index
      assigns(:tweets).should eq([tweet])
    end
  end

  describe "GET show" do
    it "assigns the requested tweet as @tweet" do
      tweet = Tweet.create! valid_attributes
      get :show, :id => tweet.id
      assigns(:tweet).should eq(tweet)
    end
  end

  describe "GET new" do
    it "assigns a new tweet as @tweet" do
      get :new
      assigns(:tweet).should be_a_new(Tweet)
    end
  end

  describe "GET edit" do
    it "assigns the requested tweet as @tweet" do
      tweet = Tweet.create! valid_attributes
      get :edit, :id => tweet.id
      assigns(:tweet).should eq(tweet)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Tweet" do
        expect {
          post :create, :tweet => valid_attributes
        }.to change(Tweet, :count).by(1)
      end

      it "assigns a newly created tweet as @tweet" do
        post :create, :tweet => valid_attributes
        assigns(:tweet).should be_a(Tweet)
        assigns(:tweet).should be_persisted
      end

      it "redirects to the created tweet" do
        post :create, :tweet => valid_attributes
        response.should redirect_to(Tweet.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved tweet as @tweet" do
        # Trigger the behavior that occurs when invalid params are submitted
        Tweet.any_instance.stub(:save).and_return(false)
        post :create, :tweet => {}
        assigns(:tweet).should be_a_new(Tweet)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Tweet.any_instance.stub(:save).and_return(false)
        post :create, :tweet => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested tweet" do
        tweet = Tweet.create! valid_attributes
        # Assuming there are no other tweets in the database, this
        # specifies that the Tweet created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Tweet.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => tweet.id, :tweet => {'these' => 'params'}
      end

      it "assigns the requested tweet as @tweet" do
        tweet = Tweet.create! valid_attributes
        put :update, :id => tweet.id, :tweet => valid_attributes
        assigns(:tweet).should eq(tweet)
      end

      it "redirects to the tweet" do
        tweet = Tweet.create! valid_attributes
        put :update, :id => tweet.id, :tweet => valid_attributes
        response.should redirect_to(tweet)
      end
    end

    describe "with invalid params" do
      it "assigns the tweet as @tweet" do
        tweet = Tweet.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Tweet.any_instance.stub(:save).and_return(false)
        put :update, :id => tweet.id, :tweet => {}
        assigns(:tweet).should eq(tweet)
      end

      it "re-renders the 'edit' template" do
        tweet = Tweet.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Tweet.any_instance.stub(:save).and_return(false)
        put :update, :id => tweet.id, :tweet => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested tweet" do
      tweet = Tweet.create! valid_attributes
      expect {
        delete :destroy, :id => tweet.id
      }.to change(Tweet, :count).by(-1)
    end

    it "redirects to the tweets list" do
      tweet = Tweet.create! valid_attributes
      delete :destroy, :id => tweet.id
      response.should redirect_to(tweets_url)
    end
  end

end
